#pragma once
#ifndef _BASEMODULE_
#define _BASEMODULE_

#ifndef BASEMODULE
#define BASEMODULE extern "C" _declspec(dllexport)
#else
#undef BASEMODULE
#define BASEMODULE extern "C" _declspec(dllimport)
#endif

#define CLSID_BASEMODULE L"{DA90D68D-99EB-45D5-A969-BC3D0D12D92A}"

#pragma pack(push,1)

class IBaseCurl;
class IServerList;
class IUserinfo;
//ȡָ
class IBaseGloablModule
{
public:
	virtual ~IBaseGloablModule(void) {}

	////ȡϢ
	//virtual LPCSTR  GetLastErrorA() = 0;
	//virtual LPCWSTR GetLastErrorW() = 0;

	virtual IBaseCurl* GetBaseCurlInstance() = 0;
 

	virtual INT AddRef() = 0;
	virtual INT Release() = 0;
};

template<typename T>
class IInstanceList
{
public:
	IInstanceList(void)
	{
		m_pNext = NULL;
		m_pPrev = NULL;
	}
	virtual ~IInstanceList(void)
	{
		Detach();
	}

	virtual void AddInstance(T* pInstance)
	{
		if (m_pNext && (m_pNext != pInstance))
			m_pNext->AddInstance(pInstance);
		else
		{
			pInstance->m_pPrev = (T*)this;
			m_pNext = pInstance;
		}
	}

	virtual void Detach()
	{
		if (m_pNext)
			m_pNext->m_pPrev = m_pPrev;
		if (m_pPrev)
			m_pPrev->m_pNext = m_pNext;

		m_pPrev = m_pNext = NULL;
	}

	T* m_pPrev;
	T* m_pNext;
};

struct SPROXY_NET
{
	int  sid;
	int  groupid;
	char addproxy[64];
	char username[64];
	char password[64];
	char processname[64];
	char title[64];
	int  port;
	int  status;
	int  id;
	int  pid;
	int  isros;
	int  proxy_type;
	bool select;
	int  count;
	int  mid;	//ģID

	 //ҽṹeǷ
	bool operator == (const SPROXY_NET& e) {
		return (this->id == e.id);
	}

	//ֵ
	bool operator == (const int& id) {
		return (this->id == id);
	}
};

struct PROESSSHOW
{
	char title[64];
	int  pid;
};

struct ProcessInfo
{
	int		id;
	wchar_t gnmae[256];
	wchar_t proceessname[256];
	int		select;
};

struct USERINFO
{
	char username[64];
	char password[64];
	char expiretime[64];
	int	id;
	int number;
	int alreadycount;
};

/**

*/
struct ServerGroup
{
	int id;
	char title[64];
};

class IServerListCallback
{
public:
	virtual ~IServerListCallback(void) {};

	virtual void ServerListCallback() = 0;
};

class IServerList
	: public IInstanceList<IServerList>
{
public:
	virtual ~IServerList(void) {};
};

class IUserinfo
	: public IInstanceList<IUserinfo>
{
public:
	virtual ~IUserinfo(void) {};
};

enum HTTPRET
{
	http_no = 0,
	http_f,
	http_yes,
	http_start,
	http_end,
};
//ӿ
class IBaseCurl
	: public IInstanceList<IBaseCurl>
{
public:
	virtual ~IBaseCurl(void) {};
	virtual HTTPRET GetHttpConnectstatus() = 0;

	virtual LPCSTR  GetLastErrorA() = 0;
};

BASEMODULE IBaseGloablModule* WINAPI GetBaseGlobalInstance();
BASEMODULE BOOL WINAPI ReleaseBaseGlobalInstance();

#pragma pack(pop)

#endif